SystemOrganization addCategory: #'O-Core-Misc'!

Interval subclass: #OstInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstInterval class methodsFor: 'instance creation' stamp: 'StefanMarr 6/6/2013 17:24'!
new
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	indexable variables. Fail if the class is indexable. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 70>
	<omniReplacement: #omniBasicNew>
	self isVariable ifTrue: [ ^ self basicNew: 0 ].
	"space must be low"
	OutOfMemory signal.
	^ self basicNew  "retry if user proceeds"! !

!OstInterval methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:47'!
species
	^ OstArray! !

Rectangle subclass: #OstRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstRectangle methodsFor: 'rectangle functions' stamp: 'StefanMarr 5/30/2013 16:46'!
intersect: aRectangle 
	"Answer a Rectangle that is the area in which the receiver overlaps with 
	aRectangle. Optimized for speed; old code read:
		^Rectangle 
			origin: (origin max: aRectangle origin)
			corner: (corner min: aRectangle corner)
	"
	| aPoint left right top bottom |
	aPoint := aRectangle origin.
	aPoint x > origin x 
		ifTrue: [ left := aPoint x ]
		ifFalse: [ left := origin x ].
	aPoint y > origin y 
		ifTrue: [ top := aPoint y ]
		ifFalse: [ top := origin y ].
	aPoint := aRectangle corner.
	aPoint x < corner x 
		ifTrue: [ right := aPoint x ]
		ifFalse: [ right := corner x ].
	aPoint y < corner y 
		ifTrue: [ bottom := aPoint y ]
		ifFalse: [ bottom := corner y ].
	^ OstRectangle 
		origin: (OstPoint x: left y: top)
		corner: (OstPoint x: right y: bottom)! !

TestCase subclass: #OstTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstTestCase commentStamp: 'StefanMarr 1/13/2013 14:02' prior: 0!
A dummy class for compatibibility with the Omni system.
In case you load omni into this image, this class can be overwritten.!

!OstTestCase methodsFor: 'asserting' stamp: 'StefanMarr 6/6/2013 11:13'!
assert: expectedA or: expectedB equals: actual
	| isEqual |
	isEqual := (expectedA = actual) or: [expectedB = actual].
	^ self
		assert: isEqual
		description: [
			String streamContents: [:stream | 
				stream
					nextPutAll: 'Expected ';
					nextPutAll: (expectedA printStringLimitedTo: 10);
					nextPutAll: ' or ';
					nextPutAll: (expectedB printStringLimitedTo: 10);
					nextPutAll: ' but was ';
					nextPutAll: (actual printStringLimitedTo: 10);
					nextPutAll: '.']]! !

!OstTestCase methodsFor: 'running' stamp: 'StefanMarr 7/3/2013 19:53'!
tearDown
	Smalltalk at: #OstMirror ifPresent: [:om | om reenableScheduling].
	^ super tearDown! !

Monitor subclass: #OstMonitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstMonitor methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:46'!
defaultQueue
	defaultQueue ifNil: [defaultQueue := OstOrderedCollection new].
	^ defaultQueue! !

!OstMonitor methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:47'!
queueDict
	^ queueDict ifNil: [queueDict := OstIdentityDictionary new].! !

Association subclass: #OstAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

Dictionary subclass: #OstDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstDictionary class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:49'!
arrayType
	^ OstArray! !

!OstDictionary class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 6/10/2013 17:19'!
initialize
	OstObject omnifyClass: self! !

!OstDictionary methodsFor: 'accessing' stamp: 'StefanMarr 5/30/2013 16:48'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (OstAssociation key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

IdentityDictionary subclass: #OstIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstIdentityDictionary class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:50'!
arrayType
	^ OstArray! !

SortedCollection subclass: #OstSortedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstSortedCollection class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:44'!
arrayType
	^ OstArray! !

Point subclass: #OstPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

Array variableSubclass: #OstArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstArray commentStamp: 'StefanMarr 1/13/2013 14:02' prior: 0!
A dummy class for compatibibility with the Omni system.
In case you load omni into this image, this class can be overwritten.!

!OstArray class methodsFor: 'instance creation' stamp: 'StefanMarr 5/31/2013 00:29'!
fromArray: anArray
	| array index |
	array := self new: anArray size.
	index := 0.
	anArray do: [:each | array at: (index := index + 1) put: each].
	^ array! !

OrderedCollection subclass: #OstOrderedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstOrderedCollection class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:51'!
arrayType
	^ OstArray! !

SharedQueue subclass: #OstSharedQueue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstSharedQueue methodsFor: 'initializing' stamp: 'StefanMarr 5/30/2013 16:45'!
initialize
	monitor := OstMonitor new.
	items   := OstOrderedCollection new.! !

Object subclass: #OPromise
	instanceVariableNames: 'signal value'
	classVariableNames: 'NoValueDelivered'
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OPromise commentStamp: 'StefanMarr 3/9/2012 21:09' prior: 0!
Provides a simple promise implementation.
A promise is a value that is going to be resolved in the future, typically by an asynchronous computation.
Reading an unresolved promise is a blocking operation.!

!OPromise class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:19'!
example
	"This is not a real test case, but just to see how it is supposed to work"
	| p |
	p := OPromise new.
	
	[|val| 
	 Transcript log: 'About to read promised value.'.
	 val := p read.
	 Transcript log: 'Val: ', val asString.] fork.

	Processor yield.
	
	Transcript log: 'About to deliver promised value.'.
	p deliver: 42.
	Transcript log: 'Deliver promised value.'.
	! !

!OPromise class methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 15:53'!
initialize
	NoValueDelivered := Object new.! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 7/19/2012 22:53'!
await
	<omniUnenforced>
	[value = NoValueDelivered] whileTrue: [
		"This is ugly, but I do not see how I can prevent the data
		 race for signals otherwise.
		 In case there are multiple possible consumers everyone
		 but the first will starve when they arrive before the
		 promise was delivered.
		 Now, we just have a delay, but it is guaranteed to return."
		"signal waitTimeoutMSecs: 100. only available in Pharo"
		(Delay new setDelay:100 forSemaphore: signal) wait.
	].! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 7/19/2012 22:53'!
deliver: aValue
	<omniUnenforced>
	"Deliver the promised value."
	
	
	"Warning: this is racy, but we don't care for the moment.
	 Should be a single produce anyway. Everything else is a bug.
	 And, we do at least best effort error notification..."
	value = NoValueDelivered ifFalse: [
		| err |
		err := Error new.
		err messageText: 'Promise has been delivered more than once.'.
		err signal.
	].

	value := aValue.
	
	signal signal.
	
	^ value.! !

!OPromise methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 16:09'!
initialize
	value := NoValueDelivered.
	signal := Semaphore new.! !

!OPromise methodsFor: 'accessing' stamp: 'StefanMarr 7/19/2012 22:59'!
read
	<omniUnenforced>
	self await.
	^ value! !

!Object methodsFor: '*O-Core-Misc' stamp: 'StefanMarr 3/14/2012 15:13'!
baselevelPerform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	^ otherTarget baselevelPerform: selector! !

Object subclass: #OstObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstObject commentStamp: 'StefanMarr 1/4/2012 14:19' prior: 0!
A dummy class for compatibibility with the Omni system.
In case you load omni into this image, this class can be overwritten.!

!OstObject class methodsFor: 'OmniST-compatibility' stamp: 'StefanMarr 9/8/2012 09:55'!
omnifyClass: aClass
	"Only here for compatibility"
	^ aClass! !

Set subclass: #OstSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstSet class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:46'!
arrayType
	^ OstArray! !

!OstSet methodsFor: 'converting' stamp: 'StefanMarr 5/30/2013 16:45'!
asArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| arr index |
	arr := OstArray new: self size.
	index := 0.
	self do: [:each | arr at: (index := index + 1) put: each].
	^ arr! !
OstDictionary initialize!
OPromise initialize!
